#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
int main()
{
    map<pair<int, int>, int> mp1, mp2;
    int T, n, k, ans;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d", &n);
        mp1.clear(), mp2.clear(), ans = 0;
        for (int i = 1; i <= n; i++)
        {
            pair<int, int> p;
            scanf("%d", &k);
            for (int j = 1; j <= k; j++)
            {
                scanf("%d%d", &p.first, &p.second);
                if (mp1[p] < i) ans = max(ans, mp2[p]), mp2[p] = 0;
                mp1[p] = i, mp2[p]++;
            }
        }
        printf("%d\n", ans);
    }
    return 0;
}